'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _armduishrdcmpnts = require('armduishrdcmpnts');

require('./Prompt.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Prompt = function (_Component) {
  _inherits(Prompt, _Component);

  function Prompt(props) {
    _classCallCheck(this, Prompt);

    var _this = _possibleConstructorReturn(this, (Prompt.__proto__ || Object.getPrototypeOf(Prompt)).call(this, props));

    _this.state = { input: '' };

    _this.handleSubmit = _this.handleSubmit.bind(_this);
    _this.handleInputChange = _this.handleInputChange.bind(_this);
    _this.handleDiscard = _this.handleDiscard.bind(_this);
    return _this;
  }

  _createClass(Prompt, [{
    key: 'show',
    value: function show() {
      var _this2 = this;

      this.setState({ show: true }, function () {
        _this2.refs.box.querySelector('input').focus();
      });
    }
  }, {
    key: 'isShowing',
    value: function isShowing() {
      return this.state.show;
    }
  }, {
    key: 'handleSubmit',
    value: function handleSubmit(e) {
      e.preventDefault();
      this.props.onConfirm(this.state.input);
      this.setState({ show: false });
    }
  }, {
    key: 'handleInputChange',
    value: function handleInputChange(e) {
      this.setState({ input: e.nativeEvent.target.value });
    }
  }, {
    key: 'handleDiscard',
    value: function handleDiscard() {
      this.props.onDiscard && this.props.onDiscard();
      this.setState({ show: false });
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;

      return _react2.default.createElement(
        'div',
        { className: 'Prompt fade-in ' + (this.state.show && 'show') },
        _react2.default.createElement(
          'form',
          { className: 'box', ref: 'box', onSubmit: this.handleSubmit },
          props.children,
          _react2.default.createElement(_armduishrdcmpnts.TextField, {
            label: props.inputLabel,
            className: 'input',
            placeholder: props.placeholder,
            value: this.state.input,
            onChange: this.handleInputChange
          }),
          _react2.default.createElement(
            'div',
            { className: 'actionButtons' },
            _react2.default.createElement(
              'button',
              { className: 'button', type: 'button', onClick: this.handleDiscard },
              props.discardLabel
            ),
            _react2.default.createElement(
              'button',
              {
                className: 'button ' + (props.confirmClassName || 'primary'),
                type: 'submit'
              },
              props.confirmLabel
            )
          )
        )
      );
    }
  }]);

  return Prompt;
}(_react.Component);

Prompt.propTypes = {
  onDiscard: _react.PropTypes.func,
  onConfirm: _react.PropTypes.func.isRequired,
  inputLabel: _react.PropTypes.string.isRequired,
  discardLabel: _react.PropTypes.string,
  confirmLabel: _react.PropTypes.string,
  confirmClassName: _react.PropTypes.string,
  placeholder: _react.PropTypes.string
};
Prompt.defaultProps = {
  discardLabel: 'Cancel',
  confirmLabel: 'Ok'
};
exports.default = Prompt;